
function love.load()
endTime = 0
love.graphics.setFont(12)
gameover = false
mute = false
explosion = love.graphics.newImage("explosion.png")
love.graphics.setIcon(love.graphics.newImage("icon.png"))
math.randomseed(os.time())
t = 0
tt = 0
f = false
player  = {
x = love.graphics:getWidth()/2-12.5,
y = love.graphics:getHeight()-150,
xvel = 0,
yvel = 0,
health = 100,
image = love.graphics.newImage("Plane.png"),
score = 0,
}
enemies = {
}
bullets = {
}
backImages = {
}
planets = {
}
explosions = {
}
back = love.graphics.newImage("stars.png")
for i=1,5 do
backImages[i] = love.graphics.newImage("Planet_"..i..".png")
end
end

function love.update(dt)
if gameover then return end
	if math.random(200*(#enemies+1))==1 then
		enemies[#enemies+1] = {
			image = love.graphics.newImage("enemy.png"),
			health = 20,
			x = math.random(love.graphics:getWidth()-50),
			y = -50,
			speedx = math.random(15,40),
			speedy = math.random(30,40),
			cooldown = 0,
		}
	end
local tr = {}
	for i=1,#enemies do
		enemies[i].y = enemies[i].y+enemies[i].speedy*dt
		enemies[i].x = enemies[i].x+enemies[i].speedx*dt
		if enemies[i].x<0 or enemies[i].x+50>love.graphics:getWidth() then
			enemies[i].speedx = enemies[i].speedx*-1
		end
		if enemies[i].cooldown <= 0 then
			fireenemy(enemies[i])
			enemies[i].cooldown = math.random(20,30)/10
		else
			enemies[i].cooldown = enemies[i].cooldown-dt
		end
		if enemies[i].y>=love.graphics:getHeight() then
			tr[#tr+1] = i
		end
	end
	for i=1,#tr do
		table.remove(enemies,tr[i])
	end
local tr = {}
	for i=1,#planets do
		if planets[i].y>=love.graphics:getHeight() then
			tr[#tr+1] = i
		end
	planets[i].y = planets[i].y+(planets[i].scale*dt*10)
	end
	for i=1,#tr do
		table.remove(planets,tr[i])
	end
	if math.random(500*(#planets+1))==1 then
		local p = {
			image = backImages[math.random(5)],
			x = math.random(-90,love.graphics:getWidth()-1),
			y = -100,
			scale = math.random(10)/10,
		}
		for i=1,#planets do -- Puts planets in the right order so that the smaller (further away) ones dont render over the larger (closer) ones
			if planets[i].scale>p.scale then
				table.insert(planets,i,p)
				return
			elseif i==#planets then
				table.insert(planets,i+1,p)
			end
		end
		if #planets==0 then -- First Planet
			planets[1]=p
		end
	end
	t = t+dt
	if t>=0.3 and f then
		t=0
		fireplane()
	end
	player.x = player.x+player.xvel*dt
	player.y = player.y+player.yvel*dt
	if player.x<0 then
		player.x = 0
	end
	if player.x+player.image:getWidth()>love.graphics:getWidth() then
		player.x = love.graphics:getWidth()-player.image:getWidth()
	end
	if player.y<0 then
		player.y = 0
	end
	if player.y+player.image:getHeight()>love.graphics:getHeight() then
		player.y = love.graphics:getHeight()-player.image:getHeight()
	end
	for i=1,#bullets do
		bullets[i].y = bullets[i].y+bullets[i].speed*dt
	end
	removebullet(dt)
	love.graphics.setCaption("Space Protector    Score: "..player.score)
		if player.health<=0 then
			endTime = os.time()
			gameover = true
		end
	local tr = {}
		for x=1,#bullets do
			for i=1,#enemies do
				if enemies[i].x<bullets[x].x and enemies[i].x+50>bullets[x].x and enemies[i].y<bullets[x].y and enemies[i].y+50>bullets[x].y and not bullets[x].en then
					enemies[i].health = enemies[i].health-bullets[x].damage
					tr[#tr+1] = x
				end
			end
		end
	for i=1,#tr do
		table.remove(bullets,tr[i])
	end
	local tr = {}
		for i=1,#explosions do
			explosions[i].t = explosions[i].t-dt
				if explosions[i].t<=0 then
					tr[#tr+1] = i
				end
		end
		for i=1,#tr do
			table.remove(explosions,tr[i])
		end
		tr = {}
		for i=1,#enemies do
			if enemies[i].health <= 0 then
				player.score = player.score+10
					if not mute then
						explode = love.audio.newSource("explosion.wav", "static")
						explode:setPitch(2)
						explode:setVolume(0.5)
						love.audio.play(explode)
					end
				explosions[#explosions+1] = {
				x = enemies[i].x,
				y = enemies[i].y,
				t = 2,
				}
				tr[#tr+1] = i
			end
		end
		for i=1,#tr do
			table.remove(enemies,tr[i])
		end

end

function removebullet(dt)
	for i=1,#bullets do
		if bullets[i].y<0 then
			table.remove(bullets,i)
			removebullet(dt)
			return
		end
		if bullets[i].y>love.graphics:getHeight() then
			table.remove(bullets,i)
			removebullet(dt)
			return
		end
		if bullets[i].x>player.x and bullets[i].x<player.x+player.image:getWidth() and bullets[i].y>player.y and bullets[i].y<player.y+player.image:getHeight() then
			player.health = player.health-bullets[i].damage
			table.remove(bullets,i)
			removebullet(dt)
			return
		end
	end
end

function love.draw()
	love.graphics.draw(back)
		for i=1,#planets do
			love.graphics.draw(planets[i].image,planets[i].x,planets[i].y,0,planets[i].scale,planets[i].scale)
		end
	for i=1,#enemies do
		love.graphics.draw(enemies[i].image,enemies[i].x,enemies[i].y)
	end
	for i=1,#explosions do
		love.graphics.draw(explosion,explosions[i].x,explosions[i].y)
	end
	love.graphics.draw(player.image,player.x,player.y)
	love.graphics.setColor(100,100,0)
	for i=1,#bullets do
		love.graphics.circle("fill",bullets[i].x,bullets[i].y,2,10)
	end
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill",0,0,100,20)
	love.graphics.setColor(0,255,0)
	love.graphics.rectangle("fill",0,0,player.health,20)
	love.graphics.setColor(255,255,255)
	if mute then
		love.graphics.printf("Muted",0,0,love.graphics:getWidth(),"right")
	end
	if gameover then
		love.graphics.setFont(30)
		love.graphics.printf("GAME OVER",0,love.graphics:getHeight()/2,love.graphics:getWidth(),"center")
		love.graphics.setFont(12)
	end
end

function love.keypressed(k,u)
	if gameover and os.time()-endTime>1 then
		love.event.push("q")
	end
	if k=="left" or k == "a" then
		player.xvel = player.xvel-100
	end
	if k=="right" or k == "d" then
		player.xvel = player.xvel+100
	end
	if k=="up" or k == "w" then
		player.yvel = player.yvel-100
	end
	if k=="down" or k == "s" then
		player.yvel = player.yvel+100
	end
	if k==" " then
		f = true
	end
	if k=="m" then
		mute = not mute
	end
end

function love.keyreleased(k,u)
	if k=="left" or k == "a" then
		player.xvel = player.xvel+100
	end
	if k=="right" or k == "d" then
		player.xvel = player.xvel-100
	end
	if k=="up" or k == "w" then
		player.yvel = player.yvel+100
	end
	if k=="down" or k == "s" then
		player.yvel = player.yvel-100
	end
	if k==" " then
		f = false
	end
end

function fireenemy(e)
	if not mute then
		fire2 = love.audio.newSource("fire.wav", "static")
		fire2:setPitch(3)
		fire2:setVolume(0.5)
		love.audio.play(fire2)
	end
	bullets[#bullets+1] = {
		x = e.x+25,
		y = e.y+60,
		speed = 100,
		damage = 10,
		en = true
	}
end

function fireplane()
	if not mute then
		fire = love.audio.newSource("fire.wav", "static")
		fire:setPitch(1.5)
		fire:setVolume(0.8)
		love.audio.play(fire)
	end
	bullets[#bullets+1] = {
		x = player.x+5,
		y = player.y-15,
		speed = -200,
		damage = 2,
		en = false
	}
	bullets[#bullets+1] = {
		x = player.x+20,
		y = player.y-15,
		speed = -200,
		damage = 2,
		en = false
	}
end